=== debian/changelog ===
icinga2 (2.10.3-2~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Chris Boot <bootc@debian.org>  Sat, 23 Mar 2019 20:47:07 +0000

icinga2 (2.10.3-2) unstable; urgency=medium

  * Team upload.
  * Add patch to fix comparepasswords_issafe test failure on i386.
  * Set CTEST_OUTPUT_ON_FAILURE environment variable.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 01 Mar 2019 12:18:30 +0100

icinga2 (2.10.3-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Bump Standards-Version to 4.3.0, no changes.
  * Use .maintscript files instead of dpkg-maintscript-helper directly.
  * Add lintian overrides for file-references-package-build-path.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 01 Mar 2019 06:52:34 +0100

icinga2 (2.10.2-1~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Chris Boot <bootc@debian.org>  Sun, 06 Jan 2019 16:27:02 +0000

icinga2 (2.10.2-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Drop 42_mips_boost_bind_workaround patch, applied upstream.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 19 Nov 2018 18:20:51 +0100

icinga2 (2.10.1-3~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Chris Boot <bootc@debian.org>  Sun, 04 Nov 2018 12:15:49 +0000

icinga2 (2.10.1-3) unstable; urgency=medium

  * Team upload.
  * Move init script & systemd service from -common to -bin package.
    (closes: #912599)

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 01 Nov 2018 20:29:09 +0100

icinga2 (2.10.1-2~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Chris Boot <bootc@debian.org>  Wed, 24 Oct 2018 21:44:08 +0100

icinga2 (2.10.1-2) unstable; urgency=medium

  * Team upload.
  * Enable USE_SYSTEMD option & change icinga2.service to notify type.
    (closes: #911672)

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 23 Oct 2018 16:47:09 +0200

icinga2 (2.10.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Update www.icinga.com URLs to icinga.com, and dev.icinga.com to GitHub.
  * Drop spelling-errors.patch, applied upstream.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 20 Oct 2018 18:03:58 +0200

icinga2 (2.10.0-1~exp1) experimental; urgency=medium

  * Team upload.
  * New upstream release.
  * Add patch to fix spelling errors.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 15 Oct 2018 07:59:08 +0200

icinga2 (2.9.2-1~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.
  * Add myself to Uploaders for this backport.
  * Update the branch name in Vcs-Git field and gbp.conf.

 -- Chris Boot <bootc@debian.org>  Wed, 03 Oct 2018 10:23:31 +0100

icinga2 (2.9.2-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Bump Standards-Version to 4.2.1, no changes.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 28 Sep 2018 07:32:37 +0200

icinga2 (2.9.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Drop spelling-errors.patch, applied upstream.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 25 Jul 2018 06:22:55 +0200

icinga2 (2.9.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Add patch by Jens Holzkämper to use check_postgres path as
    provided by check-postgres package.
    (closes: #898833)
  * Apply patch by Dmitry Bogatov to also compress 01-about.md.
    (closes: #898701)
  * Bump Standards-Version to 4.1.5, no changes.
  * Update license & copyright for mail notification scripts.
  * Bump minimum required cmake version to 2.8.8.
  * Refresh patches.
  * Drop icinga2-studio package, removed upstream.
  * Update ido install files for shim libraries.
  * Drop libicinga2 package, libraries no longer built.
  * Update spelling-errors.patch for "doesn't" typo.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 21 Jul 2018 09:05:20 +0200

icinga2 (2.8.4-2) unstable; urgency=medium

  * Team upload.
  * Fix version autopkgtest.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 08 May 2018 08:18:35 +0200

icinga2 (2.8.4-1) unstable; urgency=medium

  * Team upload.
  * Fix jQuery usage in icinga2-classicui.
    (closes: #867884, #875686)
  * Update Swedish debconf translation. Thanks to Jonatan Nyberg.
    (closes: #873009)
  * Change libreadline6 Recommends to libreadline7.
    (closes: #880488)
  * Add upstream metadata.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 05 May 2018 16:29:11 +0200

icinga2 (2.8.4-1~exp1) experimental; urgency=medium

  * Team upload.

  [ Bas Couwenberg ]
  * New upstream release.
    - CVEs fixes in 2.8.2:
      CVE-2017-16933, CVE-2018-6532, CVE-2018-6533,
      CVE-2018-6534,  CVE-2018-6535, CVE-2018-6536
    (closes: #897301, #891333, #883247)
  * Add gbp.conf to use pristine-tar by default.
  * Update copyright file, changes:
    - Update copyright years for Icinga Development Team.
    - Use stand-alone license paragraphs
    - Add license & copyright for socketpair
  * Restructure control file with cme.
  * Change priority from extra to optional.
  * Sort (build) dependencies.
  * Drop obsolete dbg package.
  * Update Vcs-* URLs for Salsa.
  * Update copyright format URL to use HTTPS.
  * Update various debian.org & icinga.com URLs to use HTTPS.
  * Bump Standards-Version to 4.1.4, changes: priority, copyright format.
  * Enable parallel globally.
  * Simplify 'disable unity builds' rules.
  * Drop obsolete dh-systemd build dependency.
  * Use DEB_BUILD_ARCH instead of DEB_HOST_ARCH, and not unconditionally.
  * Drop obsolete mysql (build) dependency alternatives.
  * Strip trailing whitespace from changelog.
  * Enable all hardening buildflags.
  * Add patch to fix spelling errors.
  * Move spelling-error-in-binary override from icinga2-bin to libicinga2.
  * Drop unused overrides for apache2-deprecated-auth-config.
  * Move rm_conffile from prerm to postrm.

